DEF VAR cProgram                      AS CHARACTER NO-UNDO.
DEF VAR cAction                       AS CHARACTER NO-UNDO.
DEF VAR cTable                        AS CHARACTER NO-UNDO.
DEF VAR iTotal                        AS INTEGER   NO-UNDO.
DEF VAR iDone                         AS INTEGER   NO-UNDO.


{System/conversion/conversion_progress.i}

DEFINE BUFFER b-aa-attachment_setting FOR aa-attachment_setting.
DEFINE BUFFER b-aa-systemcode         FOR aa-systemcode.

ASSIGN cProgram = THIS-PROCEDURE:FILE-NAME
       cAction  = "Create aa-attachment_setting -> new fields"
       iTotal   = 0
       iDone    = 0
       cTable   = "aa-attachment_setting".

DISABLE TRIGGERS FOR LOAD OF b-aa-attachment_setting.
DISABLE TRIGGERS FOR LOAD OF b-aa-systemcode.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).


  RUN CreateSystemCodeKVK.
  RUN CreateAttachmentTypeKVK.
  iDone = iDone + 1.



RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).



/* **********************  Internal Procedures  *********************** */

PROCEDURE CreateAttachmentTypeKVK:
  /*------------------------------------------------------------------------------
   Purpose: Based on setting CDS
   Notes:
  ------------------------------------------------------------------------------*/
  DEFINE VARIABLE cLocation AS CHARACTER NO-UNDO.

  DO TRANSACTION:

    FIND aa-attachment_setting WHERE
      aa-attachment_setting.recordtype  = "CDS"
      NO-LOCK NO-ERROR.

    IF AVAILABLE aa-attachment_setting
    THEN DO:
      cLocation = aa-attachment_setting.filepath.

      FIND b-aa-attachment_setting WHERE TRUE
        AND b-aa-attachment_setting.recordtype = 'DD-KVK'
        EXCLUSIVE-LOCK NO-ERROR.

      IF NOT AVAILABLE b-aa-attachment_setting
      THEN DO:
        CREATE b-aa-attachment_setting.
        ASSIGN
          b-aa-attachment_setting.recordtype    = 'DD-KVK'
          b-aa-attachment_setting.max_filesize  = 0
          b-aa-attachment_setting.filepath      = cLocation
          b-aa-attachment_setting.ind_blob      = LENGTH(cLocation) = 0 /* Indien geen path, dan in db opslaan */
          b-aa-attachment_setting.storage_days  = 0
          b-aa-attachment_setting.cleanup_seqnr = 0
          .
      END.
    END.
 END.
END PROCEDURE.

PROCEDURE CreateSystemCodeKVK:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/

DO TRANSACTION:
  FIND b-aa-systemcode WHERE TRUE
    AND b-aa-systemcode.systemtype = 'att_recordtype'
    AND b-aa-systemcode.systemcode = 'DD-KVK'
    EXCLUSIVE-LOCK NO-ERROR.

  IF NOT AVAILABLE b-aa-systemcode
  THEN DO:

    CREATE b-aa-systemcode.
    ASSIGN
      b-aa-systemcode.systemtype = 'att_recordtype'
      b-aa-systemcode.systemcode = 'DD-KVK'
      b-aa-systemcode.volgordenr = 0
      b-aa-systemcode.des        = 'DD-KVK'
      b-aa-systemcode.int_value  = 0
      .

  END.
END.
END PROCEDURE.
