
/*------------------------------------------------------------------------
    File        : aa-2301-after-01-payment_url.p
    Purpose     :

    Syntax      :

    Description : payment url (QR-code op factuur)
                  was in een tijdelijk veld gezet, nu overzetten naar
                  het nieuwe veld:  aa-invoice_header.payment_url

    Author(s)   :
    Created     : 21-10-2022 rdb
    Notes       :
                  - zet nooit een include in je conversie programma's, deze staan niet in de uitleverset
                    (met uitzondering van system/conversion.conversion_progress.i)
                  - als de database triggers niet persee af hoeven te gaan , disable ze dan

                  - gebruik de procedure 'DisplayProgress' om info/voortgang en tellers te tonen
                  - gebruik de FIELDS optie als je maar weinig velden hoeft te updaten.

                  - OF gebruik het TRANSACTION keyword als je bij de FOR EACH een EXCLUSIVE-LOCK opgeeft
                    zie onderstaand voorbeeld A

                  - OF gebruik een buffer voor de tabel als je de FOR EACH met NO-LOCK leest
                    zie onderstaand voorbeeld B

  ----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

/* Deze standaard include toevoegen aan conversie programmatuur,
   o.a de DisplayProgress procedure en input paramatere naar de
   aanroepende procedure worden hier in gedefineerd.
   Hierdoor wordt de aansluiting naar de update procedure gemaakt.

   Opmerking: Deze include wordt opgenomen in de System/comversion
              directory welke als ongecompileerd bestand.
              Het is de enige include die opgenomen mag worden in
              de conversie programmatuur.
*/
/* standalone preprocessor even op iets anders zetten als je deze handmatig wil draaien */
&SCOPED-DEFINE standalone NO

&IF {&standalone} = NO &THEN
{System/conversion/conversion_progress.i}
&ENDIF

/* ********************  Preprocessor Definitions  ******************** */


/* ***************************  Main Block  *************************** */
DEF VAR cProgram                      AS CHAR NO-UNDO.
DEF VAR cAction                       AS CHAR NO-UNDO.
DEF VAR cTable                        AS CHAR NO-UNDO.
DEF VAR cSeqcode                      AS CHAR NO-UNDO.
DEF VAR iTotal                        AS INT  NO-UNDO.
DEF VAR iDone                         AS INT  NO-UNDO.
DEF VAR iModulo                       AS INT  NO-UNDO.

cProgram =  THIS-PROCEDURE:FILE-NAME.
cAction  = "Convert payment url".
cTable = "aa-invoice_header".
iModulo =  1000.  /* om de 1000 records info tonen */


RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

/* even tellen  */
iTotal = 0.
FOR EACH aa-invoice_header NO-LOCK:
  iTotal = iTotal + 1.
END.

iDone = 0.
FOR EACH aa-invoice_header EXCLUSIVE-LOCK:
  iDone = iDone + 1.

  IF iDone MODULO iModulo = 0
  THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

  IF aa-invoice_header.applicationcode = "DP" AND 
     aa-invoice_header.ref4_left_data BEGINS "https"
  THEN 
    ASSIGN 
      aa-invoice_header.payment_url = aa-invoice_header.ref4_left_data
      aa-invoice_header.ref4_left_data = ""
      .

END.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
