USING System.cls.SPUtil.

/*------------------------------------------------------------------------
    File        : aa-2302-after-01-scheduler-logging.p
    Description : Aanpassing logging instellingen van de scheduler

*/
/* standalone preprocessor even op iets anders zetten als je deze handmatig wil draaien */
&SCOPED-DEFINE standalone NO

&IF {&standalone} = NO &THEN
{System/conversion/conversion_progress.i}
&ENDIF

/* ********************  Preprocessor Definitions  ******************** */


/* ***************************  Main Block  *************************** */
DEFINE VARIABLE cProgram                      AS CHARACTER  NO-UNDO.
DEFINE VARIABLE cAction                       AS CHARACTER NO-UNDO.
 DEFINE VARIABLE cTable                        AS CHARACTER NO-UNDO.
DEFINE VARIABLE cSeqcode                      AS CHARACTER NO-UNDO.
DEFINE VARIABLE iTotal                        AS INTEGER NO-UNDO.
DEFINE VARIABLE iDone                         AS INTEGER NO-UNDO.
DEFINE VARIABLE iModulo                       AS INTEGER   NO-UNDO.

DEFINE VARIABLE iLoop AS INTEGER NO-UNDO.
DEFINE VARIABLE cReportType AS CHARACTER NO-UNDO.
DEFINE VARIABLE cReportList AS CHARACTER NO-UNDO.

cProgram =  THIS-PROCEDURE:FILE-NAME.
cAction  = "Scheduler logging".
cTable = "aa-edi-scheduler".

DEFINE BUFFER b-aa-edi-scheduler FOR aa-edi-scheduler.
DEFINE BUFFER b-aa-edi-control   FOR aa-edi-control.


/* even tellen  */
iTotal = 0.
FOR EACH b-aa-edi-scheduler NO-LOCK:
  iTotal = iTotal + 1.
END.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).


FOR EACH b-aa-edi-scheduler EXCLUSIVE-LOCK:

  /* 2023-04-03 JEE Eenmalig zorgen dat de "debug" en "status" messages niet meer in de logging worden opgeslagen */
  FIND b-aa-edi-control WHERE
       b-aa-edi-control.controlkode = SUBSTITUTE("REPORTERRORS-&1", b-aa-edi-scheduler.schedulerid_code)
    NO-LOCK NO-ERROR.
  IF NOT AVAILABLE b-aa-edi-control
  THEN DO:
    CREATE b-aa-edi-control.
    ASSIGN
      b-aa-edi-control.controlkode = SUBSTITUTE("REPORTERRORS-&1", b-aa-edi-scheduler.schedulerid_code)
      b-aa-edi-control.lijst       = STRING(NOW)
      .
    IF LOOKUP("debug", b-aa-edi-scheduler.report_errors_types) > 0 OR
       LOOKUP("status", b-aa-edi-scheduler.report_errors_types) > 0
    THEN DO:
      DO iLoop = 1 TO NUM-ENTRIES(b-aa-edi-scheduler.report_errors_types):
        cReportType = ENTRY(iLoop, b-aa-edi-scheduler.report_errors_types).
        IF cReportType <> "debug" AND cReportType <> "status"
        THEN cReportList = SpUtil:spAddList(cReportList, cReportType).
      END. /* DO iLoop */
      b-aa-edi-scheduler.report_errors_types = cReportList.
    END. /* IF LOOKUP("debug", b-aa-edi-scheduler.report_errors_types) > 0 */

    /* 2023-04-03 JEE Als er niets in stond/staat zorgen dat er toch (een beetje) wordt gelogd */
    IF b-aa-edi-scheduler.report_errors_types = ""
    THEN b-aa-edi-scheduler.report_errors_types = "critical,error,start,stop".
  END. /* IF NOT AVAILABLE b-aa-edi-control */

  iDone = iDone + 1.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
END.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
