/* Import Reports Tabel met de laatste gegevens. */

DEFINE STREAM sImport.
DEF VAR cDataFile AS CHAR NO-UNDO.

ASSIGN
  cDataFile = SEARCH('aa/conversion/data/aa-fin_report.d')
  .

INPUT STREAM sImport FROM VALUE(cDataFile) .

DEFINE TEMP-TABLE tt-fin_report LIKE aa-fin_report .

CREATE tt-fin_report .

REPEAT ON ERROR UNDO , RETURN 'SP-ERROR' :
  
  IMPORT STREAM sImport tt-fin_report.
  
  FOR EACH sp-company NO-LOCK:

    FIND aa-fin_report 
      WHERE aa-fin_report.companycode    EQ sp-company.companycode
        AND aa-fin_report.applicatiekode EQ tt-fin_report.applicatiekode
        AND aa-fin_report.modelkode      EQ tt-fin_report.modelkode
        AND aa-fin_report.FILENAME       EQ tt-fin_report.FILENAME
      EXCLUSIVE-LOCK NO-ERROR.
      .
    
    IF NOT AVAILABLE aa-fin_report
    THEN CREATE aa-fin_report.

    BUFFER-COPY tt-fin_report TO aa-fin_report
      ASSIGN 
        aa-fin_report.companycode = sp-company.companycode
        .
    
  END.
  
END.

